;------------------------------------------------------------;
; The author, Philippe Coulombe, has given permission to use ;
; this module to the users of The GeneSys Development System ;
; and is for educational use only. Users are not allowed to  ;
; use this module in commercial software. To use this module ;
; for any for profit purpose, the author must be contacted.  ;
; Send your request directly to Philippe, ebmoluocp@yahoo.ca ;
;------------------------------------------------------------;
;           Fill lpBuffer with the clipboard text            ;
;    Return the character count of clipboard text in EAX     ;
; lpBuffer can be NULL to get the buffer size needed (bytes) ;
;------------------------------------------------------------;

.586

.MODEL FLAT, STDCALL

OPTION CASEMAP:NONE


INCLUDE \GeneSys\include\windows.inc
INCLUDE \GeneSys\include\kernel32.inc
INCLUDE \GeneSys\include\user32.inc


StrLenA                      PROTO :DWORD
StrCpyA                      PROTO :DWORD, :DWORD


.CODE

GetClipboardTextA PROC USES ebx esi p_lpBuffer:DWORD

   xor ebx, ebx    ; 0 byte length

   invoke IsClipboardFormatAvailable, CF_TEXT
   cmp eax, 0
   je Exit

   invoke OpenClipboard, NULL
   cmp eax, 0
   je Exit

   invoke GetClipboardData, CF_TEXT
   cmp eax, NULL
   je Close_Clipboard

   mov esi, eax    ; esi == clipboard object handle

   invoke GlobalLock, eax
   cmp eax, NULL
   je Close_Clipboard

   cmp p_lpBuffer, NULL
   jne @F

   invoke StrLenA, eax   ; eax == memory pointer got by GlobalLock
   inc eax   ; including null teminated char

   jmp Global_Unlock

@@:
   invoke StrCpyA, p_lpBuffer, eax   ; eax == memory pointer got by GlobalLock

Global_Unlock:

   mov ebx, eax

   invoke GlobalUnlock, esi

Close_Clipboard:

   invoke CloseClipboard

Exit:

   mov eax, ebx
   ret

GetClipboardTextA ENDP

END
