;------------------------------------------------------------;
; The author, Philippe Coulombe, has given permission to use ;
; this module to the users of The GeneSys Development System ;
; and is for educational use only. Users are not allowed to  ;
; use this module in commercial software. To use this module ;
; for any for profit purpose, the author must be contacted.  ;
; Send your request directly to Philippe, ebmoluocp@yahoo.ca ;
;------------------------------------------------------------;
; Get the parent folder of lpszPath into lpBuffer. Trailing  ;
; backslash can be appended if specified by bBackSlash.      ;
;                                                            ;
; Returns the lpBuffer pointer in EAX if successfull or NULL ;
; otherwise.                                                 ;
;------------------------------------------------------------;

.586

.MODEL FLAT, STDCALL

OPTION CASEMAP:NONE


INCLUDE \GeneSys\include\windows.inc


StrCpyA                      PROTO :DWORD, :DWORD


.CODE

;
; lpBuffer        : MAX_PATH length buffer to get parent folder and internal use
; lpszPath        : Path to process
; bBackSlash      : TRUE = Append a trailing backslash
;
GetParentFolderA PROC p_lpBuffer:DWORD, p_lpszPath:DWORD, p_bBackSlash:DWORD

   invoke StrCpyA, p_lpBuffer, p_lpszPath
   cmp eax, 3
   jb Failed

   mov edx, p_lpBuffer

   align 16
@@:
   sub eax, 1
   jz Failed
   cmp byte ptr [edx+eax], 5Ch   ; "\"
   jne @B

   cmp p_bBackSlash, FALSE
   je @F
   add eax, 1
@@:
   mov byte ptr [edx+eax], 0

   mov eax, edx   ; success = return p_lpBuffer
   ret

Failed:

   xor eax, eax
   ret

GetParentFolderA ENDP

END
