;------------------------------------------------------------;
; The author, Philippe Coulombe, has given permission to use ;
; this module to the users of The GeneSys Development System ;
; and is for educational use only. Users are not allowed to  ;
; use this module in commercial software. To use this module ;
; for any for profit purpose, the author must be contacted.  ;
; Send your request directly to Philippe, ebmoluocp@yahoo.ca ;
;------------------------------------------------------------;
; Return the character count copied in the clipboard in EAX  ;
;------------------------------------------------------------;

.586

.MODEL FLAT, STDCALL

OPTION CASEMAP:NONE


INCLUDE \GeneSys\include\windows.inc
INCLUDE \GeneSys\include\kernel32.inc
INCLUDE \GeneSys\include\user32.inc


StrLenA                      PROTO :DWORD
StrCpyA                      PROTO :DWORD, :DWORD


.CODE

SetClipboardTextA PROC USES ebx esi p_lpszText:DWORD

   xor ebx, ebx    ; 0 byte length (returned value)

   invoke OpenClipboard, NULL
   cmp eax, 0
   je Exit

   invoke EmptyClipboard
   cmp eax, 0
   je Close_Clipboard

   invoke StrLenA, p_lpszText
   cmp eax, 0
   je Close_Clipboard

   add eax, 1    ; including null-terminated char

   invoke GlobalAlloc, GMEM_MOVEABLE, eax
   cmp eax, NULL
   je Close_Clipboard

   mov esi, eax    ; esi = Memory object handle

   invoke GlobalLock, esi
   cmp eax, NULL
   je Close_Clipboard

   invoke StrCpyA, eax, p_lpszText   ; eax = Memory pointer
   mov ebx, eax
   invoke GlobalUnlock, esi

   invoke SetClipboardData, CF_TEXT, esi
   cmp eax, NULL
   jne Close_Clipboard

   xor ebx, ebx

Close_Clipboard:

   invoke CloseClipboard

Exit:

   mov eax, ebx
   ret

SetClipboardTextA ENDP

END
